# v0.01 alpha
# + added __setitem__
# + added retrying with () syntax in __getitem__
# + added debug info and win32traceutil loading
# + added unit tests
# v0.02 alpha
# + added __setattr__
# / refactor related to __setattr__
# + started building test case library
# / (not working) DOPus datatypes conversion functions

import win32traceutil

A_OBJ = "_obj"
A_NAME = "_name"
A_PARENT = "_parent"

CALL_RESULT_NAME = '<call result>'

osetattr = object.__setattr__
ogetattr = object.__getattribute__


class DOpusProxy:

    def __init__(self, obj, name='<top parent object>', parent=None):
        print('create with obj: {}, name: {}, parent: {}'.format(str(id(obj)), str(name), str(id(parent))))
        osetattr(self, A_OBJ, obj)
        osetattr(self, A_NAME, name)
        osetattr(self, A_PARENT, parent if parent else obj)

    def __getattr__(self, item):
        print('get attribute: ' + item)
        obj = ogetattr(self, A_OBJ)
        attr = eval('obj.' + item)
        return DOpusProxy(attr, item, obj)

    def __setattr__(self, key, value):
        print('set attribute: {} to: {}'.format(key, value))
        obj = ogetattr(self, A_OBJ)
        setattr(obj, key, value)

    def __setitem__(self, key, value):
        print('set item with key: {}, value {}'.format(str(key), str(value)))
        self._obj[key] = value

    def __getitem__(self, key):
        print('get item: ' + str(key))
        try:
            return self._obj[key]
        except TypeError:
            return self._obj(key)

    def __call__(self, *args, **kwargs):
        print(
            'call for name: {}, object: {} with args: {}, kwargs: {}'.format(self._name, str(id(self._obj)), str(args),
                                                                             str(kwargs)))
        if args == () and kwargs == {}:
            return DOpusProxy(self._obj, CALL_RESULT_NAME, self._obj)
        else:
            self._parent._FlagAsMethod(self._name)
            call_result = getattr(self._parent, self._name)(*args, **kwargs)
            return DOpusProxy(call_result, CALL_RESULT_NAME, call_result)

    def __str__(self):
        print('return value as string')
        return str(self._obj)

    def __int__(self):
        print('return value as integer')
        return int(self._obj)

    @property
    def obj(self):
        print('unwrap value: ' + self._name)
        return self._obj

# def to_vector(do, collection: List):
#     if isinstance(collection, list):
#         return DOpusProxy(do).Create().Vector(*collection)
#     else:
#         return None
#
#
# def from_vector(collection):
#     result = []
#     for v in vector:
#         result.append(v)
#     return result
#
#
# def to_map(do, collection: Dict):
#     if isinstance(collection, dict):
#         map = DOpusProxy(do).Create().Map()
#         for k, v in collection:
#             map[k] = v
#     else:
#         return None
#
#
# def from_map(collection):
#     result = {}
#     for key in collection:
#         result[key] = collection(key)
